package com.ccnode.codegenerator.Y;

package .tmp;

import com.ccnode.codegenerator.ae.T;
import com.ccnode.codegenerator.ae.a;
import com.google.common.collect.Sets;
import com.intellij.openapi.diagnostic.Logger;
import com.intellij.openapi.module.Module;
import com.intellij.openapi.project.DumbService;
import com.intellij.psi.ElementManipulator;
import com.intellij.psi.ElementManipulators;
import com.intellij.psi.JavaPsiFacade;
import com.intellij.psi.PsiAnnotationMemberValue;
import com.intellij.psi.PsiClass;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiModifierList;
import com.intellij.psi.PsiPackage;
import com.intellij.psi.PsiReference;
import com.intellij.psi.search.GlobalSearchScope;
import com.intellij.psi.search.SearchScope;
import com.intellij.psi.search.searches.ClassInheritorsSearch;
import com.intellij.psi.xml.XmlAttribute;
import com.intellij.psi.xml.XmlElement;
import com.intellij.spring.contexts.model.LocalAnnotationModel;
import com.intellij.spring.contexts.model.LocalModel;
import com.intellij.spring.index.SpringXmlBeansIndex;
import com.intellij.spring.model.CommonSpringBean;
import com.intellij.spring.model.SpringBeanPointer;
import com.intellij.spring.model.SpringModelSearchParameters;
import com.intellij.spring.model.converters.SpringConverterUtil;
import com.intellij.spring.model.custom.CustomLocalComponentsDiscoverer;
import com.intellij.spring.model.jam.stereotype.CustomSpringComponent;
import com.intellij.spring.model.utils.SpringCommonUtils;
import com.intellij.spring.model.utils.SpringPropertyUtils;
import com.intellij.spring.model.utils.SpringReferenceUtils;
import com.intellij.spring.model.utils.search.SpringBeanSearchParameters;
import com.intellij.spring.model.xml.beans.SpringPropertyDefinition;
import com.intellij.util.CommonProcessors;
import com.intellij.util.Processor;
import com.intellij.util.Query;
import com.intellij.util.containers.ContainerUtil;
import com.intellij.util.xml.GenericDomValue;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;
import org.apache.commons.lang.StringUtils;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class b extends CustomLocalComponentsDiscoverer {
  private static final Logger a = Logger.getInstance(com.ccnode.codegenerator.Y.b.class);
  
  public static final String a = "org.mybatis.spring.mapper.MapperScannerConfigurer";
  
  public static final String b = "tk.mybatis.spring.mapper.MapperScannerConfigurer";
  
  public static final String c = "tk.mybatis.spring.annotation.MapperScan";
  
  public static final String d = "org.mybatis.spring.annotation.MapperScan";
  
  public static final String e = "org.mybatis.spring.SqlSessionFactoryBean";
  
  public static Set<String> a = Sets.newConcurrentHashSet();
  
  @NotNull
  public Collection<CommonSpringBean> getCustomComponents(@NotNull LocalModel paramLocalModel) {
    a = Sets.newConcurrentHashSet();
    Module module = paramLocalModel.getModule();
    JavaPsiFacade javaPsiFacade = JavaPsiFacade.getInstance(module.getProject());
    Set<CommonSpringBean> set = ContainerUtil.newConcurrentSet();
    if (module != null && !DumbService.isDumb(module.getProject()) && !module.isDisposed()) {
      GlobalSearchScope globalSearchScope = GlobalSearchScope.moduleRuntimeScope(module, false);
      if (paramLocalModel instanceof com.intellij.spring.contexts.model.LocalXmlModel) {
        a(paramLocalModel, module, javaPsiFacade, set, globalSearchScope, "org.mybatis.spring.mapper.MapperScannerConfigurer");
        a(paramLocalModel, module, javaPsiFacade, set, globalSearchScope, "tk.mybatis.spring.mapper.MapperScannerConfigurer");
      } 
      if (paramLocalModel instanceof LocalAnnotationModel) {
        LocalAnnotationModel localAnnotationModel = (LocalAnnotationModel)paramLocalModel;
        PsiClass psiClass = localAnnotationModel.getConfig();
        PsiModifierList psiModifierList = psiClass.getModifierList();
        a a = T.a.a(psiModifierList, "tk.mybatis.spring.annotation.MapperScan", true, new String[] { "value", "basePackages" });
        if (!a.a())
          a = T.a.a(psiModifierList, "org.mybatis.spring.annotation.MapperScan", true, new String[] { "value", "basePackages" }); 
        if (a.a())
          for (PsiAnnotationMemberValue psiAnnotationMemberValue : a.a()) {
            String str = psiAnnotationMemberValue.getText().trim();
            if (str.length() > 2 && str.startsWith("\"") && str.endsWith("\""))
              a(str.substring(1, str.length() - 1), javaPsiFacade, set, globalSearchScope, psiAnnotationMemberValue); 
          }  
      } 
    } 
    return set;
  }
  
  private void a(@NotNull LocalModel paramLocalModel, Module paramModule, JavaPsiFacade paramJavaPsiFacade, Collection<CommonSpringBean> paramCollection, GlobalSearchScope paramGlobalSearchScope, String paramString) {
    PsiClass psiClass = SpringCommonUtils.findLibraryClass(paramModule, paramString);
    if (psiClass != null) {
      Iterator<SpringBeanPointer> iterator = a(paramModule, psiClass, paramLocalModel);
      while (iterator.hasNext()) {
        SpringBeanPointer springBeanPointer = iterator.next();
        b(paramCollection, paramJavaPsiFacade, paramGlobalSearchScope, springBeanPointer);
        a(paramCollection, paramJavaPsiFacade, paramGlobalSearchScope, springBeanPointer);
      } 
      Query query = ClassInheritorsSearch.search(psiClass, (SearchScope)paramGlobalSearchScope, false, true, false);
      Collection collection = query.findAll();
      for (PsiClass psiClass1 : collection) {
        Iterator<SpringBeanPointer> iterator1 = a(paramModule, psiClass1, paramLocalModel);
        while (iterator1.hasNext()) {
          SpringBeanPointer springBeanPointer = iterator1.next();
          b(paramCollection, paramJavaPsiFacade, paramGlobalSearchScope, springBeanPointer);
          a(paramCollection, paramJavaPsiFacade, paramGlobalSearchScope, springBeanPointer);
        } 
      } 
    } 
  }
  
  private void a(String paramString, JavaPsiFacade paramJavaPsiFacade, Collection<CommonSpringBean> paramCollection, GlobalSearchScope paramGlobalSearchScope, PsiAnnotationMemberValue paramPsiAnnotationMemberValue) {
    String str = paramString.trim();
    if (StringUtils.isBlank(paramString))
      return; 
    if (SpringConverterUtil.containsPatternReferences(paramString)) {
      Collection collection = SpringConverterUtil.getPsiPackages(a(paramPsiAnnotationMemberValue, str));
      for (PsiPackage psiPackage1 : collection)
        a(paramGlobalSearchScope, psiPackage1, paramCollection); 
      return;
    } 
    PsiPackage psiPackage = paramJavaPsiFacade.findPackage(str);
    if (psiPackage != null)
      a(paramGlobalSearchScope, psiPackage, paramCollection); 
  }
  
  @NotNull
  public PsiReference[] a(PsiAnnotationMemberValue paramPsiAnnotationMemberValue, String paramString) {
    try {
      ElementManipulator elementManipulator = ElementManipulators.getManipulator((PsiElement)paramPsiAnnotationMemberValue);
      if (elementManipulator == null) {
        a.info("create reference error for mybatis, the package name is:" + paramString);
        return PsiReference.EMPTY_ARRAY;
      } 
      int i = ElementManipulators.getOffsetInElement((PsiElement)paramPsiAnnotationMemberValue);
      return SpringReferenceUtils.getPsiPackagesReferences((PsiElement)paramPsiAnnotationMemberValue, paramString, i);
    } catch (Exception exception) {
      a.info("create reference error for mybatis, the package name is:" + paramString, exception);
      return PsiReference.EMPTY_ARRAY;
    } 
  }
  
  private void a(GlobalSearchScope paramGlobalSearchScope, PsiPackage paramPsiPackage, Collection<CommonSpringBean> paramCollection) {
    PsiClass[] arrayOfPsiClass = paramPsiPackage.getClasses(paramGlobalSearchScope);
    int i = arrayOfPsiClass.length;
    byte b1;
    for (b1 = 0; b1 < i; b1++) {
      PsiClass psiClass = arrayOfPsiClass[b1];
      if (psiClass.isInterface()) {
        a.add(psiClass.getQualifiedName());
        paramCollection.add(new CustomSpringComponent(psiClass));
      } 
    } 
    PsiPackage[] arrayOfPsiPackage = paramPsiPackage.getSubPackages(paramGlobalSearchScope);
    i = arrayOfPsiPackage.length;
    for (b1 = 0; b1 < i; b1++) {
      PsiPackage psiPackage = arrayOfPsiPackage[b1];
      a(paramGlobalSearchScope, psiPackage, paramCollection);
    } 
  }
  
  @NotNull
  private Iterator a(Module paramModule, PsiClass paramPsiClass, LocalModel paramLocalModel) {
    SpringBeanSearchParameters.BeanClass beanClass = SpringBeanSearchParameters.byClass(paramModule.getProject(), SpringModelSearchParameters.byClass(paramPsiClass));
    beanClass.setVirtualFile(paramLocalModel.getConfig().getContainingFile().getVirtualFile());
    CommonProcessors.CollectProcessor collectProcessor = new CommonProcessors.CollectProcessor();
    SpringXmlBeansIndex.processBeansByClass(beanClass, (Processor)collectProcessor);
    return collectProcessor.getResults().iterator();
  }
  
  private void a(Collection<CommonSpringBean> paramCollection, JavaPsiFacade paramJavaPsiFacade, GlobalSearchScope paramGlobalSearchScope, SpringBeanPointer paramSpringBeanPointer) {
    a(paramCollection, paramJavaPsiFacade, paramGlobalSearchScope, SpringPropertyUtils.findPropertyByName(paramSpringBeanPointer.getSpringBean(), "markerInterface"));
  }
  
  private static void a(@NotNull Collection<CommonSpringBean> paramCollection, @NotNull JavaPsiFacade paramJavaPsiFacade, @NotNull GlobalSearchScope paramGlobalSearchScope, @Nullable SpringPropertyDefinition paramSpringPropertyDefinition) {
    if (paramSpringPropertyDefinition != null) {
      String str = paramSpringPropertyDefinition.getValueAsString();
      if (str != null) {
        PsiClass psiClass = paramJavaPsiFacade.findClass(str, paramGlobalSearchScope);
        if (psiClass != null) {
          paramCollection.add(new CustomSpringComponent(psiClass));
          Iterator<PsiClass> iterator = ClassInheritorsSearch.search(psiClass, (SearchScope)paramGlobalSearchScope, true).findAll().iterator();
          while (iterator.hasNext()) {
            PsiClass psiClass1 = iterator.next();
            String str1 = psiClass1.getQualifiedName();
            if (str1 != null) {
              a.add(str1);
              paramCollection.add(new CustomSpringComponent(psiClass1));
            } 
          } 
        } 
      } 
    } 
  }
  
  private static void b(Collection<CommonSpringBean> paramCollection, JavaPsiFacade paramJavaPsiFacade, GlobalSearchScope paramGlobalSearchScope, SpringBeanPointer paramSpringBeanPointer) {
    SpringPropertyDefinition springPropertyDefinition = SpringPropertyUtils.findPropertyByName(paramSpringBeanPointer.getSpringBean(), "basePackage");
    if (springPropertyDefinition != null) {
      String str = springPropertyDefinition.getValueAsString();
      if (StringUtils.isNotBlank(str)) {
        if (SpringConverterUtil.containsPatternReferences(str)) {
          XmlElement xmlElement = springPropertyDefinition.getValueElement().getXmlElement();
          if (xmlElement instanceof XmlAttribute) {
            XmlAttribute xmlAttribute = (XmlAttribute)xmlElement;
            Collection collection1 = SpringConverterUtil.getPsiPackages(a(springPropertyDefinition.getValueElement(), (PsiElement)xmlAttribute
                  .getValueElement()));
            for (PsiPackage psiPackage : collection1)
              a(paramGlobalSearchScope, psiPackage, paramCollection, paramSpringBeanPointer); 
          } 
        } 
        Collection collection = SpringConverterUtil.getPackages(str, a(), springPropertyDefinition.getXmlElement().getProject());
        for (PsiPackage psiPackage : collection)
          a(paramGlobalSearchScope, psiPackage, paramCollection, paramSpringBeanPointer); 
      } 
    } 
  }
  
  protected static String a() {
    return ",; \n\t";
  }
  
  @NotNull
  public static PsiReference[] a(GenericDomValue paramGenericDomValue, PsiElement paramPsiElement) {
    String str = paramGenericDomValue.getStringValue();
    return SpringReferenceUtils.getPsiPackagesReferences(paramPsiElement, str, ElementManipulators.getOffsetInElement(paramPsiElement), a(), GlobalSearchScope.allScope(paramPsiElement.getProject()));
  }
  
  private static void a(GlobalSearchScope paramGlobalSearchScope, PsiPackage paramPsiPackage, Collection<CommonSpringBean> paramCollection, SpringBeanPointer paramSpringBeanPointer) {
    PsiClass[] arrayOfPsiClass = paramPsiPackage.getClasses(paramGlobalSearchScope);
    int i = arrayOfPsiClass.length;
    byte b1;
    for (b1 = 0; b1 < i; b1++) {
      PsiClass psiClass = arrayOfPsiClass[b1];
      if (psiClass.isInterface()) {
        String str = psiClass.getQualifiedName();
        if (str != null) {
          a.add(str);
          paramCollection.add(new CustomSpringComponent(psiClass));
        } 
      } 
    } 
    PsiPackage[] arrayOfPsiPackage = paramPsiPackage.getSubPackages(paramGlobalSearchScope);
    i = arrayOfPsiPackage.length;
    for (b1 = 0; b1 < i; b1++) {
      PsiPackage psiPackage = arrayOfPsiPackage[b1];
      a(paramGlobalSearchScope, psiPackage, paramCollection, paramSpringBeanPointer);
    } 
  }
}
